# CAP定理
## 简介
CAP 理论，也称为 Brewer's 定理，是指在分布式系统设计中的三个基本要素之间的权衡问题。这三个要素是一致性（Consistency）、可用性（Availability）和分区容错性（Partition Tolerance）。
- 一致性：在分布式系统中，一致性表示所有节点在同一时间具有相同的数据副本。当一个节点对数据进行更改后，所有其他节点都应立即看到这个更改。
- 可用性：可用性指的是系统能够提供响应并完成操作的能力，即使在面对部分故障或网络分区的情况下也可以持续运行。在可用性方面，系统必须保证对用户请求做出响应而不产生延迟。
- 分区容错性：分区容忍性意味着系统可以继续正常运行，即使在面对网络分区、节点故障或消息丢失等情况下也不会中断。

CAP 理论表明，无法同时满足一致性、可用性和分区容错性这三个要求。 在任何分布式系统中，只能同时满足其中的两个，而必须在第三个上做出妥协。例如:
- CA：强调一致性和可用性，但在面对网络分区时可能会出现故障。
- CP：强调一致性和分区容错性，但在面对部分故障时可能会牺牲可用性。
- AP：强调可用性和分区容错性，但在面对部分故障时可能会牺牲一致性。

### 网络分区
> 网络分区指的是在分布式系统中，由于网络故障或其他原因导致节点之间无法相互通信或数据传输的情况。

![CAP](./imgs/cap.jpg)





